IMPLEMENTATION MODULE DrvClk;
  (*
    Copyright (C) 1993-1995, Alex Iakovlev & Dimon Maslov
    ******************************************************************
    Hardware :  IBM PC/XT/AT ROM BIOS
    OpSystems:  MS-DOS Ver 3.0+
    ------------------------------------------------------------------
    A.Iakovlev  Ver  1.0  Initial version                  July 90
    A.Iakovlev  Ver  1.1  Use switch module OpSystem       July 90
    A.Iakovlev  Ver  2.0  Renaming                         June 93
    A.Iakovlev  Ver  2.1  No OS/2 support                  February 94
    A.Iakovlev  Ver  2.2  Use module SrvSys                February 94
    A.Iakovlev  Ver  3.0  Procedure Delay                  April 94
    A.Iakovlev  Ver  4.0  Renaming                         March 95
    ******************************************************************
    Hardware dependencies:
    ------ call BIOS via interrupt 15H
    ------ function 86H
    MS-DOS dependencies:
    ------ call MS-DOS via interrupt 21H
    ------ function 2CH
  *)

  IMPORT SrvSys;

  CONST
    HoursPerHalfDay = 12;
    SecondsPerHour = 3600;
    SecondsPerMinute = 60;
    DosInterrupt = 21H;
    GetTimeFun = 2CH;
    ATExtendedServicesInterrupt = 15H;
    WaitFunc = 86H;

  PROCEDURE Time(): CARDINAL;
    VAR
      reg: SrvSys.Registers;
    BEGIN
      reg.AH := GetTimeFun;
      SrvSys.Int(reg, DosInterrupt);
      RETURN
        (ORD(reg.CH) MOD HoursPerHalfDay) * SecondsPerHour +
         ORD(reg.CL) * SecondsPerMinute +
         ORD(reg.DH);
    END Time;

  PROCEDURE Delay(millisecs: CARDINAL);
    CONST
      WordShift = 10000H;
    VAR
      reg: SrvSys.Registers;
      time: LONGCARD;
    BEGIN
      time := VAL(LONGCARD, millisecs) * 1000;
      reg.AH := WaitFunc;
      reg.CX := VAL(CARDINAL, time DIV WordShift);
      reg.DX := VAL(CARDINAL, time MOD WordShift);
      SrvSys.Int(reg, ATExtendedServicesInterrupt);
    END Delay;

  END DrvClk.
