IMPLEMENTATION MODULE Scr;
  (*
    Copyright (C) 1993-1995, Alex Iakovlev & Dimon Maslov
    *************************************************************************
    A.Iakovlev  Ver  1.0                                          July 87
    A.Iakovlev  Ver  1.1  Corr. for LOGITECH ver 2.00             October 87
    A.Iakovlev  Ver  2.0  Procedures InitBM, InitPatt             October 87
    A.Iakovlev  Ver  3.0  Union with ScreenFonts                  December 87
    A.Iakovlev  Ver  3.1  Local modules                           December 87
    A.Iakovlev  Ver  4.0  Pages                                   January 88
    A.Iakovlev  Ver  5.0  Cursors                                 February 88
    A.Iakovlev  Ver  5.1  Erasure of local modules                February 88
    A.Iakovlev  Ver  5.2  Corr. for LOGITECH ver 3.00             May 88
    A.Iakovlev  Ver  6.0  New module Geo                          August 88
    A.Iakovlev  Ver  6.1  Pixmaps buffer                          October 88
    A.Iakovlev  Ver  7.0  GetPicture and PutPicture               November 88
    A.Iakovlev  Ver  8.0  Simplifications                         February 89
    A.Iakovlev  Ver  9.0  Clipping mode on pixmaps                March 89
    A.Iakovlev  Ver  9.1  Correction in NewPixmap                 March 89
    A.Iakovlev  Ver  9.2  Erasure of absolute vars                March 89
    A.Iakovlev  Ver 10.0  New module Geo                          March 89
    A.Iakovlev  Ver 10.1  JPI-like BIOS calls                     March 89
    A.Iakovlev  Ver 11.0  Procedures DHL and DVL                  March 89
    A.Iakovlev  Ver 12.0  New viewport/clipping procs             April 89
    A.Iakovlev  Ver 12.1  Left buffer shifting                    April 89
    A.Iakovlev  Ver 13.0  Pixmap clearing, copying, swapping      April 89
    A.Iakovlev  Ver 13.1  Shifting in proc. DrawBuffer            July 89
    A.Iakovlev  Ver 13.2  Inline code for shifting                July 89
    A.Iakovlev  Ver 13.3  Corr. in calls of SetDrawParameters     August 89
    A.Iakovlev  Ver 14.0  Use M2VERS utility                      August 89
    A.Iakovlev  Ver 15.0  Pointer variable in Get/PutPicture      September 89
    A.Iakovlev  Ver 16.0  Renaming                                January 90
    A.Iakovlev  Ver 17.0  Open array variable in NewFont          January 90
    A.Iakovlev  Ver 17.1  JPI-only version                        January 90
    A.Iakovlev  Ver 18.0  Drawing mode in pixmap descr.           February 90
    A.Iakovlev  Ver 19.0  Changes in viewport and clipping        February 90
    A.Iakovlev  Ver 20.0  Devices                                 February 90
    A.Iakovlev  Ver 21.0  No devices again                        February 90
    A.Iakovlev  Ver 21.1  Corr. in SetDrawParam. and DrawBuffer   March 90
    A.Iakovlev  Ver 21.2  Structured constants                    March 90
    A.Iakovlev  Ver 22.0  No procedure PhysicalDims               March 90
    A.Iakovlev  Ver 22.1  No moving position in DCH               March 90
    A.Iakovlev  Ver 23.0  VAR-parameter fd in NewFont             March 90
    A.Iakovlev  Ver 23.1  Corr. in NewPixmap (invalid DIV)        March 90
    A.Iakovlev  Ver 24.0  Simplifications                         June 90
    A.Iakovlev  Ver 25.0  Partitions store/restore                June 90
    A.Iakovlev  Ver 26.0  Return status in Init/New/Dispose       June 90
    A.Iakovlev  Ver 26.1  Conditional compilation for MS-DOS/OS2  July 90
    A.Iakovlev  Ver 27.0  Renaming                                July 90
    A.Iakovlev  Ver 27.1  Use switch module OpSystem              July 90
    A.Iakovlev  Ver 27.2  Error correction in PointColor          August 90
    A.Iakovlev  Ver 28.0  Partition number in PartSize            August 90
    A.Iakovlev  Ver 28.1  Use assembler module Utils              August 90
    A.Iakovlev  Ver 29.0  Screen page origins                     September 90
    A.Iakovlev  Ver 30.0  Renaming Point and PointColor           October 90
    A.Iakovlev  Ver 31.0  New checks => Status, Dispose changed   October 90
    A.Iakovlev  Ver 31.1  Corrections in procedure Test           November 90
    A.Iakovlev  Ver 32.0  Sub-drivers and procedure variables     December 90
    A.Iakovlev  Ver 32.1  Procedure Prev => module Obj            January 91
    A.Iakovlev  Ver 32.2  Separate configuration module           January 91
    A.Iakovlev  Ver 32.3  Corrections in InitGraph/TermGraph      February 91
    A.Iakovlev  Ver 32.4  Modified VGA modes                      May 91
    A.Iakovlev  Ver 33.0  Screen enable/disable                   May 91
    A.Iakovlev  Ver 34.0  Procedure Test in definition module     May 91
    A.Iakovlev  Ver 34.1  16-color VGA Palette                    June 91
    A.Iakovlev  Ver 35.0  Palette parameter in SetShade/Shade     June 91
    A.Iakovlev  Ver 35.1  No WITH in OS/2 SetShade  for TS 3.02   January 92
    A.Iakovlev  Ver 35.2  Vio.MODEINFO + GetVersion for TS 3.02   January 92
    A.Iakovlev  Ver 35.3  Use new versions of modules PS & RC     January 92
    A.Iakovlev  Ver 35.4  Protection switch                       January 92
    A.Iakovlev  Ver 35.5  Use combined low-level module RM        January 92
    A.Iakovlev  Ver 36.0  Procedure FontInfo                      January 92
    A.Iakovlev  Ver 36.1  Version for TopSpeed DOS Extender       January 92
    A.Iakovlev  Ver 36.2  No support for CGA adapter              August 92
    A.Iakovlev  Ver 37.0  Variable procedures New/Dispose         August 92
    A.Iakovlev  Ver 38.0  Use module Res                          August 92
    A.Iakovlev  Ver 39.0  Dynamic graphics modes                  August 92
    A.Iakovlev  Ver 40.0  Palette control in separate module RP   August 92
    A.Iakovlev  Ver 41.0  No pages, single font adddress          August 92
    A.Iakovlev  Ver 42.0  Pragma data(var_enum_size)              August 92
    A.Iakovlev  Ver 43.0  Mode 376 x 348 instead of 400 x 327     August 92
    A.Iakovlev  Ver 44.0  Renaming                                June 93
    A.Iakovlev  Ver 45.0  Autodetection of Super-VGA hardware     June 93
    A.Iakovlev  Ver 45.1  Correct memory determination            June 93
    A.Iakovlev  Ver 46.0  Mass palette shades procedures          June 93
    A.Iakovlev  Ver 47.0  Import from SYSTEM                      January 94
    A.Iakovlev  Ver 47.1  Use SrvSys.Nrm instead of Lib.AddAddr   January 94
    A.Iakovlev  Ver 47.2  No use SHORTCARD type                   January 94
    A.Iakovlev  Ver 47.3  No OS/2 support                         February 94
    A.Iakovlev  Ver 47.4  Stony Brook support                     February 94
    A.Iakovlev  Ver 47.5  New module ScrExt                       March 94
    A.Iakovlev  Ver 48.0  No empty modes and procedures           March 94
    A.Iakovlev  Ver 49.0  Additional 256-color graphics modes     March 94
    A.Iakovlev  Ver 49.1  No procedure GetFontInfo                March 94
    A.Iakovlev  Ver 50.0  Color type = Pixel (LONGCARD)           September 94
    A.Iakovlev  Ver 51.0  High and true color modes               October 94
    A.Iakovlev  Ver 52.0  Direct color control                    February 95
    A.Iakovlev  Ver 52.1  Use single driver for all Pk8-modes     March 95
    A.Iakovlev  Ver 53.0  Procedure RGBColor                      March 95
    A.Iakovlev  Ver 54.0  Renaming                                March 95
    **************************************************************************
  *)

  IMPORT
    SYSTEM,
    Geo, Res, SrvObj,
    ScrTyp, ScrVar, ScrBas, ScrExt, ScrPal, ScrDir, ScrLow,
    ScrPl4, ScrNc8, ScrPk;

  (* ============================================ Basic types *)

  TYPE
    PIXMAP = ScrTyp.PIXMAP;
    FontDescriptor =
      RECORD
        addr: SYSTEM.ADDRESS;
        wdt, hgt: CARDINAL;
        set: BOOLEAN;
      END;

  (* =============== Mode control constants, types, variables and procedures *)

  VAR
    curMode: Type;
    curOrg, orgsPerPage: CARDINAL;
    wasInit, videoEnabled: BOOLEAN;
    STDFONT: ARRAY [0 .. ScrExt.MaxNmbOfStdFonts - 1] OF FontDescriptor;
    storeAndInitPalette, restorePalette, termPageAddrs: PROC;
    initPage: PROCEDURE(CARDINAL, CARDINAL);
    initPageAddrs: PROCEDURE(CARDINAL);

  PROCEDURE SetDriverPlanar4();
    BEGIN
      initPage := ScrPl4.InitPage;
      initPageAddrs := ScrPl4.InitPageAddrs;
      termPageAddrs := ScrPl4.TermPageAddrs;
      New := ScrPl4.New;
      Clear := ScrPl4.Clear;
      Copy := ScrPl4.Copy;
      Dispose := ScrPl4.Dispose;
      Pt := ScrPl4.Pt;
      SolidRect := ScrPl4.SolidRect;
      StippledRect := ScrPl4.StippledRect;
      PtColor := ScrPl4.PtColor;
      RectCopy := ScrPl4.RectCopy;
      PartsNmb := ScrPl4.PartsNmb;
      PartSize := ScrPl4.PartSize;
      Store := ScrPl4.Store;
      Restore := ScrPl4.Restore;
    END SetDriverPlanar4;

  PROCEDURE SetDriverNonChain8();
    BEGIN
      initPage := ScrNc8.InitPage;
      initPageAddrs := ScrNc8.InitPageAddrs;
      termPageAddrs := ScrNc8.TermPageAddrs;
      New := ScrNc8.New;
      Clear := ScrNc8.Clear;
      Copy := ScrNc8.Copy;
      Dispose := ScrNc8.Dispose;
      Pt := ScrNc8.Pt;
      SolidRect := ScrNc8.SolidRect;
      StippledRect := ScrNc8.StippledRect;
      PtColor := ScrNc8.PtColor;
      RectCopy := ScrNc8.RectCopy;
      PartsNmb := ScrNc8.PartsNmb;
      PartSize := ScrNc8.PartSize;
      Store := ScrNc8.Store;
      Restore := ScrNc8.Restore;
    END SetDriverNonChain8;

  PROCEDURE SetDriverPacked();
    BEGIN
      ScrPk.SetMode(curMode);
      initPage := ScrPk.InitPage;
      initPageAddrs := ScrPk.InitPageAddrs;
      termPageAddrs := ScrPk.TermPageAddrs;
      New := ScrPk.New;
      Clear := ScrPk.Clear;
      Copy := ScrPk.Copy;
      Dispose := ScrPk.Dispose;
      Pt := ScrPk.Pt;
      SolidRect := ScrPk.SolidRect;
      StippledRect := ScrPk.StippledRect;
      PtColor := ScrPk.PtColor;
      RectCopy := ScrPk.RectCopy;
      PartsNmb := ScrPk.PartsNmb;
      PartSize := ScrPk.PartSize;
      Store := ScrPk.Store;
      Restore := ScrPk.Restore;
    END SetDriverPacked;

  PROCEDURE SetPaletteDriver4();
    BEGIN
      IF ScrBas.adapter = ScrBas.vga THEN
        PaletteShadesNmb := ScrPal.PaletteShadesNmbVGA4;
        SetPaletteShade := ScrPal.SetPaletteShadeVGA4;
        PaletteShade := ScrPal.PaletteShadeVGA4;
        PaletteShadesSize := ScrPal.PaletteShadesSizeVGA4;
        SetPaletteShades := ScrPal.SetPaletteShadesVGA4;
        SetDirectPaletteShades := ScrPal.SetDirectPaletteShadesVGA4;
        PaletteShades := ScrPal.PaletteShadesVGA4;
        PalettesNmb := ScrPal.PalettesNmbVGA4;
        SetPalette := ScrPal.SetPaletteVGA4;
        Palette := ScrPal.PaletteVGA4;
        storeAndInitPalette := ScrPal.StoreAndInitPaletteVGA4;
        restorePalette := ScrPal.RestorePaletteVGA4;
      ELSE
        PaletteShadesNmb := ScrPal.PaletteShadesNmbEGA4;
        SetPaletteShade := ScrPal.SetPaletteShadeEGA4;
        PaletteShade := ScrPal.PaletteShadeEGA4;
        PaletteShadesSize := ScrPal.PaletteShadesSizeEGA4;
        SetPaletteShades := ScrPal.SetPaletteShadesEGA4;
        SetDirectPaletteShades := ScrPal.SetDirectPaletteShadesEGA4;
        PaletteShades := ScrPal.PaletteShadesEGA4;
        PalettesNmb := ScrPal.PalettesNmbEGA4;
        SetPalette := ScrPal.SetPaletteEGA4;
        Palette := ScrPal.PaletteEGA4;
        storeAndInitPalette := ScrPal.StoreAndInitPaletteEGA4;
        restorePalette := ScrPal.RestorePaletteEGA4;
      END;
    END SetPaletteDriver4;

  PROCEDURE SetPaletteDriver8();
    BEGIN
      PaletteShadesNmb := ScrPal.PaletteShadesNmbVGA8;
      SetPaletteShade := ScrPal.SetPaletteShadeVGA8;
      PaletteShade := ScrPal.PaletteShadeVGA8;
      PaletteShadesSize := ScrPal.PaletteShadesSizeVGA8;
      SetPaletteShades := ScrPal.SetPaletteShadesVGA8;
      SetDirectPaletteShades := ScrPal.SetDirectPaletteShadesVGA8;
      PaletteShades := ScrPal.PaletteShadesVGA8;
      PalettesNmb := ScrPal.PalettesNmbVGA8;
      SetPalette := ScrPal.SetPaletteVGA8;
      Palette := ScrPal.PaletteVGA8;
      storeAndInitPalette := ScrPal.StoreAndInitPaletteVGA8;
      restorePalette := ScrPal.RestorePaletteVGA8;
    END SetPaletteDriver8;

  PROCEDURE SetPaletteDriverEmpty();
    BEGIN
      PaletteShadesNmb := ScrPal.PaletteShadesNmbEmpty;
      SetPaletteShade := ScrPal.SetPaletteShadeEmpty;
      PaletteShade := ScrPal.PaletteShadeEmpty;
      PaletteShadesSize := ScrPal.PaletteShadesSizeEmpty;
      SetPaletteShades := ScrPal.SetPaletteShadesEmpty;
      SetDirectPaletteShades := ScrPal.SetDirectPaletteShadesEmpty;
      PaletteShades := ScrPal.PaletteShadesEmpty;
      PalettesNmb := ScrPal.PalettesNmbEmpty;
      SetPalette := ScrPal.SetPaletteEmpty;
      Palette := ScrPal.PaletteEmpty;
      storeAndInitPalette := ScrPal.StoreAndInitPaletteEmpty;
      restorePalette := ScrPal.RestorePaletteEmpty;
    END SetPaletteDriverEmpty;

  PROCEDURE SetDirectColorDriver4();
    BEGIN
      DirectShadesNmb := ScrDir.DirectShadesNmb4;
      SetDirectShade := ScrDir.SetDirectShade4;
      DirectShade := ScrDir.DirectShade4;
    END SetDirectColorDriver4;

  PROCEDURE SetDirectColorDriver8();
    BEGIN
      DirectShadesNmb := ScrDir.DirectShadesNmb8;
      SetDirectShade := ScrDir.SetDirectShade8;
      DirectShade := ScrDir.DirectShade8;
    END SetDirectColorDriver8;

  PROCEDURE SetDirectColorDriver15();
    BEGIN
      DirectShadesNmb := ScrDir.DirectShadesNmb15;
      SetDirectShade := ScrDir.SetDirectShade15;
      DirectShade := ScrDir.DirectShade15;
    END SetDirectColorDriver15;

  PROCEDURE SetDirectColorDriver16();
    BEGIN
      DirectShadesNmb := ScrDir.DirectShadesNmb16;
      SetDirectShade := ScrDir.SetDirectShade16;
      DirectShade := ScrDir.DirectShade16;
    END SetDirectColorDriver16;

  PROCEDURE SetDirectColorDriver24();
    BEGIN
      DirectShadesNmb := ScrDir.DirectShadesNmb24;
      SetDirectShade := ScrDir.SetDirectShade24;
      DirectShade := ScrDir.DirectShade24;
    END SetDirectColorDriver24;

  PROCEDURE SetGlobals();
    BEGIN
      (* ---------------------------------------- set number of page origins *)
      IF ScrExt.testPassed THEN
        orgsPerPage := ScrExt.linesPerPage - ScrExt.Profiles[curMode].linesPerScreen + 1;
      ELSE
        orgsPerPage := 1;
      END;
      (* ---------------------------------------- initialize screen page *)
      initPage(ScrExt.bytesPerLine, ScrExt.linesPerPage);
    END SetGlobals;

  PROCEDURE SetMode4x320x200();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode4x320x200;
        SetDriverPlanar4();
        SetPaletteDriver4();
        SetDirectColorDriver4();
        ScrExt.PrepareStandard(curMode);
        SetGlobals();
      END;
    END SetMode4x320x200;

  PROCEDURE SetMode4x640x200();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode4x640x200;
        SetDriverPlanar4();
        SetPaletteDriver4();
        SetDirectColorDriver4();
        ScrExt.PrepareStandard(curMode);
        SetGlobals();
      END;
    END SetMode4x640x200;

  PROCEDURE SetMode4x640x350();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode4x640x350;
        SetDriverPlanar4();
        SetPaletteDriver4();
        SetDirectColorDriver4();
        ScrExt.PrepareStandard(curMode);
        SetGlobals();
      END;
    END SetMode4x640x350;

  PROCEDURE SetMode4x640x480();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode4x640x480;
        SetDriverPlanar4();
        SetPaletteDriver4();
        SetDirectColorDriver4();
        ScrExt.PrepareStandard(curMode);
        SetGlobals();
      END;
    END SetMode4x640x480;

  PROCEDURE SetMode8x320x200();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode8x320x200;
        SetDriverPacked();
        SetPaletteDriver8();
        SetDirectColorDriver8();
        ScrExt.PrepareStandard(curMode);
        SetGlobals();
      END;
    END SetMode8x320x200;

  PROCEDURE SetMode8x320x400();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode8x320x400;
        SetDriverNonChain8();
        SetPaletteDriver8();
        SetDirectColorDriver8();
        ScrExt.PrepareModified(curMode);
        SetGlobals();
      END;
    END SetMode8x320x400;

  PROCEDURE SetMode8x376x348();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode8x376x348;
        SetDriverNonChain8();
        SetPaletteDriver8();
        SetDirectColorDriver8();
        ScrExt.PrepareModified(curMode);
        SetGlobals();
      END;
    END SetMode8x376x348;

  PROCEDURE SetMode4x800x600();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode4x800x600;
        SetDriverPlanar4();
        SetPaletteDriver4();
        SetDirectColorDriver4();
        ScrExt.PrepareSuper(curMode);
        SetGlobals();
      END;
    END SetMode4x800x600;

  PROCEDURE SetMode8x640x400();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode8x640x400;
        SetDriverPacked();
        SetPaletteDriver8();
        SetDirectColorDriver8();
        ScrExt.PrepareSuper(curMode);
        SetGlobals();
      END;
    END SetMode8x640x400;

  PROCEDURE SetMode8x640x480();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode8x640x480;
        SetDriverPacked();
        SetPaletteDriver8();
        SetDirectColorDriver8();
        ScrExt.PrepareSuper(curMode);
        SetGlobals();
      END;
    END SetMode8x640x480;

  PROCEDURE SetMode8x800x600();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode8x800x600;
        SetDriverPacked();
        SetPaletteDriver8();
        SetDirectColorDriver8();
        ScrExt.PrepareSuper(curMode);
        SetGlobals();
      END;
    END SetMode8x800x600;

  PROCEDURE SetMode8x1024x768();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode8x1024x768;
        SetDriverPacked();
        SetPaletteDriver8();
        SetDirectColorDriver8();
        ScrExt.PrepareSuper(curMode);
        SetGlobals();
      END;
    END SetMode8x1024x768;

  PROCEDURE SetMode8x1280x1024();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode8x1280x1024;
        SetDriverPacked();
        SetPaletteDriver8();
        SetDirectColorDriver8();
        ScrExt.PrepareSuper(curMode);
        SetGlobals();
      END;
    END SetMode8x1280x1024;

  PROCEDURE SetMode15x320x200();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode15x320x200;
        SetDriverPacked();
        SetPaletteDriverEmpty();
        SetDirectColorDriver15();
        ScrExt.PrepareSuper(curMode);
        SetGlobals();
      END;
    END SetMode15x320x200;

  PROCEDURE SetMode15x640x480();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode15x640x480;
        SetDriverPacked();
        SetPaletteDriverEmpty();
        SetDirectColorDriver15();
        ScrExt.PrepareSuper(curMode);
        SetGlobals();
      END;
    END SetMode15x640x480;

  PROCEDURE SetMode15x800x600();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode15x800x600;
        SetDriverPacked();
        SetPaletteDriverEmpty();
        SetDirectColorDriver15();
        ScrExt.PrepareSuper(curMode);
        SetGlobals();
      END;
    END SetMode15x800x600;

  PROCEDURE SetMode15x1024x768();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode15x1024x768;
        SetDriverPacked();
        SetPaletteDriverEmpty();
        SetDirectColorDriver15();
        ScrExt.PrepareSuper(curMode);
        SetGlobals();
      END;
    END SetMode15x1024x768;

  PROCEDURE SetMode16x320x200();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode16x320x200;
        SetDriverPacked();
        SetPaletteDriverEmpty();
        SetDirectColorDriver16();
        ScrExt.PrepareSuper(curMode);
        SetGlobals();
      END;
    END SetMode16x320x200;

  PROCEDURE SetMode16x640x480();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode16x640x480;
        SetDriverPacked();
        SetPaletteDriverEmpty();
        SetDirectColorDriver16();
        ScrExt.PrepareSuper(curMode);
        SetGlobals();
      END;
    END SetMode16x640x480;

  PROCEDURE SetMode16x800x600();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode16x800x600;
        SetDriverPacked();
        SetPaletteDriverEmpty();
        SetDirectColorDriver16();
        ScrExt.PrepareSuper(curMode);
        SetGlobals();
      END;
    END SetMode16x800x600;

  PROCEDURE SetMode16x1024x768();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode16x1024x768;
        SetDriverPacked();
        SetPaletteDriverEmpty();
        SetDirectColorDriver16();
        ScrExt.PrepareSuper(curMode);
        SetGlobals();
      END;
    END SetMode16x1024x768;

  PROCEDURE SetMode24x320x200();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode24x320x200;
        SetDriverPacked();
        SetPaletteDriverEmpty();
        SetDirectColorDriver24();
        ScrExt.PrepareSuper(curMode);
        SetGlobals();
      END;
    END SetMode24x320x200;

  PROCEDURE SetMode24x640x480();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode24x640x480;
        SetDriverPacked();
        SetPaletteDriverEmpty();
        SetDirectColorDriver24();
        ScrExt.PrepareSuper(curMode);
        SetGlobals();
      END;
    END SetMode24x640x480;

  PROCEDURE SetMode24x800x600();
    BEGIN
      IF NOT wasInit THEN
        curMode := mode24x800x600;
        SetDriverPacked();
        SetPaletteDriverEmpty();
        SetDirectColorDriver24();
        ScrExt.PrepareSuper(curMode);
        SetGlobals();
      END;
    END SetMode24x800x600;

  PROCEDURE SetMode(m: Type);
    BEGIN
      CASE m OF
      | mode4x320x200  : SetMode4x320x200();
      | mode4x640x200  : SetMode4x640x200();
      | mode4x640x350  : SetMode4x640x350();
      | mode4x640x480  : SetMode4x640x480();
      | mode8x320x200  : SetMode8x320x200();
      | mode8x320x400  : SetMode8x320x400();
      | mode8x376x348  : SetMode8x376x348();
      | mode4x800x600  : SetMode4x800x600();
      | mode8x640x400  : SetMode8x640x400();
      | mode8x640x480  : SetMode8x640x480();
      | mode8x800x600  : SetMode8x800x600();
      | mode8x1024x768 : SetMode8x1024x768();
      | mode8x1280x1024: SetMode8x1280x1024();
      | mode15x320x200 : SetMode15x320x200();
      | mode15x640x480 : SetMode15x640x480();
      | mode15x800x600 : SetMode15x800x600();
      | mode15x1024x768: SetMode15x1024x768();
      | mode16x320x200 : SetMode16x320x200();
      | mode16x640x480 : SetMode16x640x480();
      | mode16x800x600 : SetMode16x800x600();
      | mode16x1024x768: SetMode16x1024x768();
      | mode24x320x200 : SetMode24x320x200();
      | mode24x640x480 : SetMode24x640x480();
      | mode24x800x600 : SetMode24x800x600();
      END;
    END SetMode;

  PROCEDURE Mode(): Type;
    BEGIN
      RETURN curMode;
    END Mode;

  (* =============================== Initilization/Termination *)

  PROCEDURE InitGraph(): Res.Status;
    BEGIN
      IF wasInit THEN
        RETURN Res.done;
      ELSIF ScrExt.testPassed THEN
        (* --------------- adapter initialization *)
        ScrExt.Init();
        (* ---------------------- screen page initialization *)
        initPageAddrs(ScrExt.videoSel);
        (* ------------------------------------ screen clearing *)
        Clear(PagePixmap(), 0);
        (* ---------------------------------------- enable video *)
        EnableVideo();
        (* ------ store old and initialize current palette *)
        storeAndInitPalette();
        (* -------------------- normal end *)
        wasInit := TRUE;
        RETURN Res.done;
      ELSE
        RETURN Res.modeNotSupported;
      END;
    END InitGraph;

  PROCEDURE TermGraph();
    BEGIN
      IF wasInit THEN
        (* ---------------- restore old palette *)
        restorePalette();
        (* ------------------- screen pages termination *)
        termPageAddrs();
        (* --------------------------- adapter termination *)
        ScrExt.Term();
        (* --------------------- normal end *)
        wasInit := FALSE;
      END;
    END TermGraph;

  (* ================================ Mode-independent control procedures *)

  PROCEDURE PageOrgsNmb(): CARDINAL;
    BEGIN
      RETURN orgsPerPage;
    END PageOrgsNmb;

  PROCEDURE SetPageOrg(origin: CARDINAL);
    BEGIN
      (* ------------------------ correct parameter *)
      origin := origin MOD orgsPerPage;
      (* ------------------------------ set the page origin (iff need) *)
      IF origin # curOrg THEN
        ScrExt.SetDisplayStart(0, origin);
        curOrg := origin;
      END;
    END SetPageOrg;

  PROCEDURE PageOrg(): CARDINAL;
    BEGIN
      RETURN curOrg;
    END PageOrg;

  PROCEDURE ColorsNmb(): LONGCARD;
    BEGIN
      RETURN ScrExt.Profiles[curMode].colorsPerPixel;
    END ColorsNmb;

  PROCEDURE Dims(VAR w, h: CARDINAL);
    BEGIN
      WITH ScrExt.Profiles[curMode] DO
        w := pixelsPerLine;
        h := linesPerScreen;
      END;
    END Dims;

  PROCEDURE FontInfo(n: CARDINAL; VAR w, h: CARDINAL; VAR a: SYSTEM.ADDRESS);
    BEGIN
      n := n MOD ScrExt.MaxNmbOfStdFonts;
      WITH STDFONT[n] DO
        IF NOT set THEN
          ScrExt.FontInfo(n, wdt, hgt, addr);
          set := TRUE;
        END;
        w := wdt;
        h := hgt;
        a := addr;
      END;
    END FontInfo;

  PROCEDURE Graph(): BOOLEAN;
    BEGIN
      RETURN wasInit;
    END Graph;

  PROCEDURE Test(): BOOLEAN;
    BEGIN
      RETURN ScrExt.testPassed;
    END Test;

  PROCEDURE EnableVideo();
    BEGIN
      IF NOT videoEnabled THEN
        CASE ScrBas.adapter OF
        | ScrBas.ega:
          ScrLow.EnableVideo();
        | ScrBas.vga:
          ScrLow.VGAEnableVideo();
        ELSE
        END;
        videoEnabled := TRUE;
      END;
    END EnableVideo;

  PROCEDURE DisableVideo();
    BEGIN
      IF videoEnabled THEN
        CASE ScrBas.adapter OF
        | ScrBas.ega:
          ScrLow.DisableVideo();
        | ScrBas.vga:
          ScrLow.VGADisableVideo();
        ELSE
        END;
        videoEnabled := FALSE;
      END;
    END DisableVideo;

  PROCEDURE Video(): BOOLEAN;
    BEGIN
      RETURN videoEnabled;
    END Video;

  (* ============================================= Direct color control *)

  PROCEDURE RGBColor(r, g, b: CARDINAL): Pixel;
    VAR
      c: Pixel;
    BEGIN
      c := 0;
      SetDirectShade(c, red  , r);
      SetDirectShade(c, green, g);
      SetDirectShade(c, blue , b);
      RETURN c;
    END RGBColor;

  (* =========================================== Pixmap control *)

  PROCEDURE PagePixmap(): PIXMAP;
    BEGIN
      RETURN SYSTEM.ADR(ScrVar.SPM);
    END PagePixmap;

  PROCEDURE Surface(pm: PIXMAP; VAR r: Geo.Rectangle);
    BEGIN
      WITH pm^ DO
        r := surf;
      END;
    END Surface;

  PROCEDURE Exist(pm: PIXMAP): BOOLEAN;
    BEGIN
      RETURN SrvObj.Exist(SrvObj.OBJECT(ScrVar.topPm), SrvObj.OBJECT(pm));
    END Exist;

  (* ================================== Pixmap viewports and clipping *)

  PROCEDURE Viewport(pm: PIXMAP; VAR v: View);
    BEGIN
      WITH pm^ DO
        v := view;
      END;
    END Viewport;

  PROCEDURE SetViewport(pm: PIXMAP; v: View);
    BEGIN
      WITH pm^ DO
        view := v;
      END;
    END SetViewport;

  PROCEDURE SwapViewport(pm: PIXMAP; new: View; VAR old: View);
    BEGIN
      WITH pm^ DO
        old := view;
        view := new;
      END;
    END SwapViewport;

  PROCEDURE Clip(pm: PIXMAP; VAR c: BOOLEAN);
    BEGIN
      WITH pm^ DO
        c := view.clip;
      END;
    END Clip;

  PROCEDURE SetClip(pm: PIXMAP; c: BOOLEAN);
    BEGIN
      WITH pm^ DO
        view.clip := c;
      END;
    END SetClip;

  PROCEDURE SwapClip(pm: PIXMAP; new: BOOLEAN; VAR old: BOOLEAN);
    BEGIN
      WITH pm^ DO
        old := view.clip;
        view.clip := new;
      END;
    END SwapClip;

  (* ============================================ Initialization *)

  VAR font: CARDINAL;

  BEGIN
    (* --------------- initialize some of the globals *)
    wasInit := FALSE;
    videoEnabled := TRUE;
    FOR font := 0 TO ScrExt.MaxNmbOfStdFonts - 1 DO
      STDFONT[font].set := FALSE;
    END;
  END Scr.
