IMPLEMENTATION MODULE SrvSys;
  (*
    Copyright (C) 1993-1995, Alex Iakovlev & Dimon Maslov
    *********************************************************************
    Compilers:  TopSpeed / Stony Brook Modula-2
    ---------------------------------------------------------------------
    A.Iakovlev  Ver  1.0  Initial version                     February 94
    *********************************************************************
    TopSpeed compiler dependencies:
    ------ pointer constructor
    Stony Brook dependencies:
    ------ address fields SEGMENT & OFFSET
    TopSpeed library dependencies:
    ------ import from SYSTEM: Registers, Seg, Ofs
    ------ import from Lib: Intr, AddAddr
    Stony Brook library dependencies:
    ------ import from SYSTEM: REGISTERS, INT
  *)

  FROM Cfg IMPORT CMPTS, CMPSB;
  IMPORT SYSTEM;

  (*%T CMPTS*)
  IMPORT Lib;
  (*%E*)

  (* =================================== System procedures *)

  (*%T CMPTS*)

  PROCEDURE Add(a: SYSTEM.ADDRESS; x: CARDINAL): SYSTEM.ADDRESS;
    BEGIN
      RETURN Lib.AddAddr(a, x);
    END Add;

  PROCEDURE Addr(seg, ofs: CARDINAL): SYSTEM.ADDRESS;
    BEGIN
      RETURN [seg:ofs];
    END Addr;

  PROCEDURE Split(a: SYSTEM.ADDRESS; VAR seg, ofs: CARDINAL);
    BEGIN
      seg := SYSTEM.Seg(a^);
      ofs := SYSTEM.Ofs(a^);
    END Split;

  PROCEDURE Int(VAR reg: Registers; num: CARDINAL);
    BEGIN
      Lib.Intr(reg, num);
    END Int;

  PROCEDURE IntRes(VAR reg: Registers; num: CARDINAL): BITSET;
    BEGIN
      Lib.Intr(reg, num);
      RETURN reg.Flags;
    END IntRes;

  (*%E*)

  (*%T CMPSB*)

  PROCEDURE Add(a: SYSTEM.ADDRESS; x: CARDINAL): SYSTEM.ADDRESS;
    BEGIN
      INC(a.OFFSET, x);
      RETURN a;
    END Add;

  PROCEDURE Addr(seg, ofs: CARDINAL): SYSTEM.ADDRESS;
    VAR
      a: SYSTEM.ADDRESS;
    BEGIN
      a.SEGMENT := seg;
      a.OFFSET := ofs;
      RETURN a;
    END Addr;

  PROCEDURE Split(a: SYSTEM.ADDRESS; VAR seg, ofs: CARDINAL);
    BEGIN
      seg := a.SEGMENT;
      ofs := a.OFFSET;
    END Split;

  PROCEDURE Int(VAR reg: Registers; num: CARDINAL);
    BEGIN
      SYSTEM.INT(num, reg);
    END Int;

  PROCEDURE IntRes(VAR reg: Registers; num: CARDINAL): BITSET;
    BEGIN
      SYSTEM.INT(num, reg);
      RETURN reg.FLAGS;
    END IntRes;

  (*%E*)

  END SrvSys.
